// -*- C++ -*-
/*!
 * @file  Jaco_Test_PS4.cpp
 * @brief Jaco by PS4
 * @date $Date$
 *
 * $Id$
 */

#include "Jaco_Test_PS4.h"
int result;
int button[20];//hex->2
int A_FLG=0;//
int B_FLG=0;//
char c[8];

CartesianPosition currentCommand;
CartesianPosition dataCommand;
CartesianPosition dataPosition;
AngularPosition dataCommand_A;
AngularPosition dataPosition_A;
AngularPosition torque;
AngularPosition torqueGravityFree;
AngularPosition current;
TrajectoryPoint Target_Point;

//Handle for the library's command layer.
void * commandLayer_handle;
//Function pointers to the functions we need
int Device_NUM;
int (*ARM_InitAPI)();
int (*ARM_CloseAPI)();
int (*ARM_SendBasicTrajectory)(TrajectoryPoint command);
int (*ARM_GetDevices)(KinovaDevice devices[MAX_KINOVA_DEVICE], int &result);
int (*ARM_SetActiveDevice)(KinovaDevice device);
int (*ARM_MoveHome)();
int (*ARM_InitFingers)();
int (*ARM_GetQuickStatus)(QuickStatus &);
int (*ARM_GetCartesianCommand)(CartesianPosition &);
int (*ARM_GetCartesianPosition)(CartesianPosition &);
int (*ARM_GetAngularCommand)(AngularPosition &);
int (*ARM_GetAngularPosition)(AngularPosition &);
int (*ARM_GetAngularCurrent)(AngularPosition &Response);
int (*ARM_GetAngularForce)(AngularPosition &Response);
int (*ARM_GetAngularForceGravityFree)(AngularPosition &Response);




Link LINK_R;
Link LINK_T;
Link Trans_Matrix[10];
Link Transed_Matrix[10];
// Module specification
// <rtc-template block="module_spec">
static const char* jaco_test_ps4_spec[] =
  {
    "implementation_id", "Jaco_Test_PS4",
    "type_name",         "Jaco_Test_PS4",
    "description",       "Jaco by PS4",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
Jaco_Test_PS4::Jaco_Test_PS4(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_Controller_TypeIn("Controller_Type", m_Controller_Type),
    m_ButtonIn("Button", m_Button),
    m_AnalogIn("Analog", m_Analog)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
Jaco_Test_PS4::~Jaco_Test_PS4()
{
}



RTC::ReturnCode_t Jaco_Test_PS4::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers 
	m_Analog.data.length(11);
	addInPort("Controller_Type", m_Controller_TypeIn);
	addInPort("Button", m_ButtonIn);
	addInPort("Analog", m_AnalogIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>
	commandLayer_handle = dlopen("Kinova.API.USBCommandLayerUbuntu.so",RTLD_NOW|RTLD_GLOBAL);

	ARM_InitAPI = (int (*)()) dlsym(commandLayer_handle,"InitAPI");
	ARM_CloseAPI = (int (*)()) dlsym(commandLayer_handle,"CloseAPI");
	ARM_MoveHome = (int (*)()) dlsym(commandLayer_handle,"MoveHome");
	ARM_InitFingers = (int (*)()) dlsym(commandLayer_handle,"InitFingers");
	ARM_GetDevices = (int (*)(KinovaDevice devices[MAX_KINOVA_DEVICE], int &result)) dlsym(commandLayer_handle,"GetDevices");
	ARM_SetActiveDevice = (int (*)(KinovaDevice devices)) dlsym(commandLayer_handle,"SetActiveDevice");
	ARM_SendBasicTrajectory = (int (*)(TrajectoryPoint)) dlsym(commandLayer_handle,"SendBasicTrajectory");
	ARM_GetQuickStatus = (int (*)(QuickStatus &)) dlsym(commandLayer_handle,"GetQuickStatus");
	ARM_GetCartesianCommand = (int (*)(CartesianPosition &)) dlsym(commandLayer_handle,"GetCartesianCommand");
	ARM_GetCartesianPosition = (int (*)(CartesianPosition &)) dlsym(commandLayer_handle,"GetCartesianPosition");
	ARM_GetAngularCommand = (int (*)(AngularPosition &)) dlsym(commandLayer_handle,"GetAngularCommand");
	ARM_GetAngularPosition = (int (*)(AngularPosition &)) dlsym(commandLayer_handle,"GetAngularPosition");
	ARM_GetAngularCurrent = (int (*)(AngularPosition &Response)) dlsym(commandLayer_handle,"GetAngularCurrent");
	ARM_GetAngularForce = (int (*)(AngularPosition &Response)) dlsym(commandLayer_handle,"GetAngularForce");
	ARM_GetAngularForceGravityFree = (int (*)(AngularPosition &Response)) dlsym(commandLayer_handle,"GetAngularForceGravityFree");
	
	cout << "----------------------------Initialize----------------------------" << endl;
	if((ARM_InitAPI == NULL) || (ARM_CloseAPI == NULL) ||
	   (ARM_GetQuickStatus == NULL) || (ARM_SendBasicTrajectory == NULL) ||
	   (ARM_SendBasicTrajectory == NULL) || (ARM_MoveHome == NULL) || (ARM_InitFingers == NULL) ||
	   (ARM_GetCartesianCommand == NULL)|| (ARM_GetCartesianPosition == NULL) || (ARM_GetAngularCommand == NULL)
	    || (ARM_GetAngularPosition == NULL) || (ARM_GetAngularCurrent == NULL) || (ARM_GetAngularForce == NULL) || (ARM_GetAngularForceGravityFree == NULL) )
	{
		cout << "Init Fail" << endl;
	}
	else
	{
		cout << "Init" << endl;
		result = (*ARM_InitAPI)();
		KinovaDevice list[MAX_KINOVA_DEVICE];
		Device_NUM = ARM_GetDevices(list, result);
		cout << "Device NUM : "<<Device_NUM<< endl;
	
		for(int i = 0; i < Device_NUM; i++)
		{
			cout << "Jaco2 : " << list[i].SerialNumber << endl;
			//Setting the current device as the active device.
			ARM_SetActiveDevice(list[i]);

			cout << "HOME position" << endl;
			//ARM_MoveHome();
			cout << "Init finger" << endl;
			ARM_InitFingers();
		}
	}
	
	Target_Point.InitStruct();
	Target_Point.Position.Type = CARTESIAN_VELOCITY;

	Target_Point.Position.CartesianPosition.X = 0;
	Target_Point.Position.CartesianPosition.Y = 0; 
	Target_Point.Position.CartesianPosition.Z = 0;
	Target_Point.Position.CartesianPosition.ThetaX = 0;
	Target_Point.Position.CartesianPosition.ThetaY = 0;
	Target_Point.Position.CartesianPosition.ThetaZ = 0;

	Target_Point.Position.Fingers.Finger1 = 0;
	Target_Point.Position.Fingers.Finger2 = 0;
	Target_Point.Position.Fingers.Finger3 = 0;
	
	cout << "------------------------------------------------------------------" << endl;

	if(Device_NUM==0){
			cerr << "Can't Find Devices!" << endl;
			return RTC::RTC_ERROR;
	}
  // <rtc-template block="bind_config">
  // </rtc-template>
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onFinalize()
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onActivated(RTC::UniqueId ec_id)
{ 

	cout << "HOME position" << endl;
	ARM_MoveHome();
	cout << "Init finger" << endl;
	ARM_InitFingers();
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onDeactivated(RTC::UniqueId ec_id)
{
if(Device_NUM!=0){//アーム接続有り
			cout << "HOME position" << endl;
			ARM_MoveHome();//ホームポジションへ
			cout << "Init finger" << endl;
			ARM_InitFingers();//指先初期化
			}
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onExecute(RTC::UniqueId ec_id)
{

if(Device_NUM!=0){//アーム接続有り

        int i=0;

////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////状態取得//////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
	(*ARM_GetCartesianCommand)(dataCommand);//姿勢指令値
	(*ARM_GetCartesianPosition)(dataPosition);//姿勢現在値
	(*ARM_GetAngularCommand)(dataCommand_A);//各軸指令値
	(*ARM_GetAngularPosition)(dataPosition_A);//各軸現在値
	ARM_GetAngularCurrent(current);//各軸現在消費電流［Ａ］
	ARM_GetAngularForce(torque);//各軸現在負荷［Ｎ＊ｍ］
	ARM_GetAngularForceGravityFree(torqueGravityFree);//各軸現在負荷［Ｎ＊ｍ］　重力キャンセル版
////////////////////////////////////////////////////////////////////////////////////////
	if(m_ButtonIn.isNew()){//ボタンデータが来た
	  	m_ButtonIn.read();//ボタンデータyomikomi 
	  	sprintf(c,"%04x",m_Button.data);//cにボタンデータ格納
	  	//4個の１６進数を１６個の２進数へ
	 	for(i=0;i<5;i++){

		  	switch(c[i]){
			      case '1':  //0001
				      button[3+4*(- i + 3) ]=0;
				      button[2+4*(- i + 3) ]=0;
				      button[1+4*(- i + 3) ]=0;
				      button[4*(- i + 3) ]=1;
			      break;
			      
			      case '2':  //0010
				      button[3+4*(- i + 3) ]=0;
				      button[2+4*(- i + 3) ]=0;
				      button[1+4*(- i + 3) ]=1;
				      button[4*(- i + 3) ]=0;
			      break;
			      
			      case '3':  //0011
				      button[3+4*(- i + 3) ]=0;
				      button[2+4*(- i + 3) ]=0;
				      button[1+4*(- i + 3) ]=1;
				      button[4*(- i + 3) ]=1;
			      break;
			      
			      case '4':  //0100
				      button[3+4*(- i + 3) ]=0;
				      button[2+4*(- i + 3) ]=1;
				      button[1+4*(- i + 3) ]=0;
				      button[4*(- i + 3) ]=0;
			      break;
			      
			      case '5':  //0101
				      button[3+4*(- i + 3) ]=0;
				      button[2+4*(- i + 3) ]=1;
				      button[1+4*(- i + 3) ]=0;
				      button[4*(- i + 3) ]=1;
			      break;
			      
			      case '6':  //0110
				      button[3+4*(- i + 3) ]=0;
				      button[2+4*(- i + 3) ]=1;
				      button[1+4*(- i + 3) ]=1;
				      button[4*(- i + 3) ]=0;
			      break;
			      
			      case '7':  //0111
				      button[3+4*(- i + 3) ]=0;
				      button[2+4*(- i + 3) ]=1;
				      button[1+4*(- i + 3) ]=1;
				      button[4*(- i + 3) ]=1;
			      break;
			      
			      case '8':  //1000
				      button[3+4*(- i + 3) ]=1;
				      button[2+4*(- i + 3) ]=0;
				      button[1+4*(- i + 3) ]=0;
				      button[4*(- i + 3) ]=0;
			      break;
			      case '9':  //1001
				      button[3+4*(- i + 3) ]=1;
				      button[2+4*(- i + 3) ]=0;
				      button[1+4*(- i + 3) ]=0;
				      button[4*(- i + 3) ]=1;
			      break;
			      
			      case 'A':  //1010
			      case 'a':  //1010
				      button[3+4*(- i + 3) ]=1;
				      button[2+4*(- i + 3) ]=0;
				      button[1+4*(- i + 3) ]=1;
				      button[4*(- i + 3) ]=0;
			      break;
			      
			      case 'B':  //1011
			      case 'b':  //1011
				      button[3+4*(- i + 3) ]=1;
				      button[2+4*(- i + 3) ]=0;
				      button[1+4*(- i + 3) ]=1;
				      button[4*(- i + 3) ]=1;
			      break;
			      
			      case 'C':  //1100
			      case 'c':  //1100
				      button[3+4*(- i + 3) ]=1;
				      button[2+4*(- i + 3) ]=1;
				      button[1+4*(- i + 3) ]=0;
				      button[4*(- i + 3) ]=0;
			      break;
			      
			      case 'D':  //1101
			      case 'd':  //1101
				      button[3+4*(- i + 3) ]=1;
				      button[2+4*(- i + 3) ]=1;
				      button[1+4*(- i + 3) ]=0;
				      button[4*(- i + 3) ]=1;
			      break;
			      
			      case 'E':  //1110
			      case 'e':  //1110
				      button[3+4*(- i + 3) ]=1;
				      button[2+4*(- i + 3) ]=1;
				      button[1+4*(- i + 3) ]=1;
				      button[4*(- i + 3) ]=0;
			      break;
			      
			      case 'F':  //1111
			      case 'f':  //1111
				      button[3+4*(- i + 3) ]=1;
				      button[2+4*(- i + 3) ]=1;
				      button[1+4*(- i + 3) ]=1;
				      button[4*(- i + 3) ]=1;
			      break;
			      
			      default://0000
				      button[3+4*(- i + 3) ]=0;
				      button[2+4*(- i + 3) ]=0;
				      button[1+4*(- i + 3) ]=0;
				      button[4*(- i + 3) ]=0;
			      break;
		  //num[i]= strtoul(ni_input, &e, 2);

			}
        }
	Button_Rename();//ボタンデータ名前変更　ＳＱＡＲＥ　ＳＨＡＲＥ　等
	B_FLG=1;//ボタンデータ有り
 
	if(m_AnalogIn.isNew()){//アナログデータ有り
		m_AnalogIn.read();//アナログデータ読み込み
		Analog_Rename();//アナログデータ名前変更　ＬＥＦＴ＿Ｘ　ＲＩＧＨＴ＿Ｙ　Ｌ２＿Ａ　等

		Target_Point.Position.CartesianPosition.Y = LEFT_X/10;//左スティックを前後に倒す動作を　アームＹ軸の変化分へ
		Target_Point.Position.CartesianPosition.X = -LEFT_Y/10;//左スティックを左右に倒す動作を　アームＸ軸の変化分へ
		//Target_Point.Position.CartesianPosition.Z = -(L2_A+1.0)/1;
		//Target_Point.Position.CartesianPosition.Z =  (R2_A+1.0)/1;
		Target_Point.Position.CartesianPosition.Z =  (R2_A - L2_A)/2;//Ｌ２、Ｒ２ボタン押し込み量を　アームＺ軸の変化分へ
		
		
		Target_Point.Position.CartesianPosition.ThetaX = -RIGHT_X/1;//右スティックを前後に倒す動作を　アームＸ　ＲＯＬＬ軸の変化分へ
		Target_Point.Position.CartesianPosition.ThetaY = -RIGHT_Y/1;//左スティックを左右に倒す動作を　アームＹ　ＰＩＴＣＨ軸の変化分へ
		
		//Ｚ　ＹＡＷ軸の変化分へ
		if(L1){//Ｌ１ボタン　ＣＣＷ
			Target_Point.Position.CartesianPosition.ThetaZ = -2;
			}
		if(R1){//Ｒ１ボタン　ＣＷ
			Target_Point.Position.CartesianPosition.ThetaZ = 2;
			}
		if(L1 == 0 && R1 ==0 ){//Ｌ１,Ｒ１ボタン押されていなければ　動かない
					Target_Point.Position.CartesianPosition.ThetaZ = 0;
			}
			
		
		if( HAT_UP ){//十字キー　↑　押している間３本指開き続ける
			Target_Point.Position.Fingers.Finger1 = 3000;
			Target_Point.Position.Fingers.Finger2 = 3000;
			Target_Point.Position.Fingers.Finger3 = 3000;
		}else if( HAT_DOWN ){//十字キー　↓　押している間３本指閉じ続ける
			Target_Point.Position.Fingers.Finger1 = -3000;
			Target_Point.Position.Fingers.Finger2 = -3000;
			Target_Point.Position.Fingers.Finger3 = -3000;
		}else if( HAT_LEFT ){//十字キー　←　押している間２本指閉じ続ける
			Target_Point.Position.Fingers.Finger1 = -3000;
			Target_Point.Position.Fingers.Finger2 = -3000;
			Target_Point.Position.Fingers.Finger3 = 0;
		}else if( HAT_RIGHT ){//十字キー　→　押している間２本指開き続ける
			Target_Point.Position.Fingers.Finger1 = 3000;
			Target_Point.Position.Fingers.Finger2 = 3000;
			Target_Point.Position.Fingers.Finger3 = 0;
		}else{//十字キー　押されていなければ動かない
			Target_Point.Position.Fingers.Finger1 = 0;
			Target_Point.Position.Fingers.Finger2 = 0;
			Target_Point.Position.Fingers.Finger3 = 0;
		}
		if (Touch ){//タッチボタンでホームポジションへ
			ARM_MoveHome();
			ARM_InitFingers();
			}
			
		Printer();
	
	}else{
	
	
	}
	
	ARM_SendBasicTrajectory(Target_Point);
	usleep(2500);
	
	
	
	 }else{
	  	for(i=0;i<20;i++){
	  		button[i]=0;
	  	}
	B_FLG=0;
  }//Button
}else{
	 // return RTC::RTC_ERROR;
}
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::Button_Rename()
{
	SQARE=button[0];
	CROSS=button[1];
	CIRCLE=button[2];
	TRIANGLE=button[3];
	L1=button[4];
	R1=button[5];
	L2=button[6];
	R2=button[7];
	SHARE=button[8];
	OPTION=button[9];
	L3=button[10];
	R3=button[11];
	PS=button[12];
	Touch=button[13];
#ifdef _DEBUG
	if(SQARE)
  	std::cerr<<"\x1b[1m" <<"\x1b[35m" << "□"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(CROSS)
  	std::cerr<<"\x1b[1m" <<"\x1b[36m" << "✕"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(CIRCLE)
  	std::cerr<<"\x1b[1m" <<"\x1b[31m" << "○"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(TRIANGLE)
  	std::cerr<<"\x1b[1m" <<"\x1b[32m" << "△"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(L1)
  	std::cerr<<"\x1b[1m" <<"\x1b[37m" << "L1"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(R1)
  	std::cerr<<"\x1b[1m" <<"\x1b[37m" << "R1"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(L2)
  	std::cerr<<"\x1b[1m" <<"\x1b[37m" << "L2"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(R2)
  	std::cerr<<"\x1b[1m" <<"\x1b[37m" << "L2"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(SHARE)
  	std::cerr<<"\x1b[1m" <<"\x1b[34m" << "SHARE"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(OPTION)
  	std::cerr<<"\x1b[1m" <<"\x1b[35m" << "OPTION"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(L3)
  	std::cerr<<"\x1b[1m" <<"\x1b[37m" << "L3"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(R3)
  	std::cerr<<"\x1b[1m" <<"\x1b[37m" << "R3"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(PS)
  	std::cerr<<"\x1b[1m" <<"\x1b[35m" << "PS"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(Touch)
  	std::cerr<<"\x1b[1m" <<"\x1b[36m" << "Touch"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
#endif
  return RTC::RTC_OK;
}
RTC::ReturnCode_t Jaco_Test_PS4::Analog_Rename()
{

	if(m_Analog.data[0]==-1){
		HAT_UP=1;
		HAT_DOWN=0;
	}else if(m_Analog.data[0]==1){
	 	HAT_UP=0;
	 	HAT_DOWN=1;
	}else{
		HAT_UP=0;
		HAT_DOWN=0;
	}
	if(m_Analog.data[1]==-1){
		HAT_RIGHT=0;
		HAT_LEFT=1;
	}else if(m_Analog.data[1]==1){
	 	HAT_RIGHT=1;
	 	HAT_LEFT=0;
	}else{
		HAT_RIGHT=0;
		HAT_LEFT=0;
	}

	LEFT_X=m_Analog.data[2];
	LEFT_Y=m_Analog.data[3];
	RIGHT_X=m_Analog.data[4];
	RIGHT_Y=m_Analog.data[5];
	L2_A=m_Analog.data[6];
	R2_A=m_Analog.data[7];
#ifdef _DEBUG
	if(HAT_UP)
  	std::cerr<<"\x1b[1m" <<"\x1b[35m" << "↑"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(HAT_DOWN)
  	std::cerr<<"\x1b[1m" <<"\x1b[36m" << "↓"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(HAT_RIGHT)
  	std::cerr<<"\x1b[1m" <<"\x1b[31m" << "→"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	if(HAT_LEFT)
  	std::cerr<<"\x1b[1m" <<"\x1b[32m" << "←"<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	//L_X
	std::cerr<<"\x1b[1m" <<"\x1b[37m" << LEFT_X<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	//L_Y
  	std::cerr<<"\x1b[1m" <<"\x1b[37m" <<LEFT_Y<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	//R_X
  	std::cerr<<"\x1b[1m" <<"\x1b[37m" <<RIGHT_X<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	//R_Y
  	std::cerr<<"\x1b[1m" <<"\x1b[37m" << RIGHT_Y<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	//L2
  	std::cerr<<"\x1b[1m" <<"\x1b[34m" <<L2_A<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	//R2
  	std::cerr<<"\x1b[1m" <<"\x1b[35m" << R2_A<<"\x1b[39m"<<"\x1b[0m"<< std::endl ;
	
#endif
  return RTC::RTC_OK;
}


RTC::ReturnCode_t Jaco_Test_PS4::Printer(){
	cout << "*********************************" << endl;
	cout << "X   command : " << dataCommand.Coordinates.X << " m" << "     Position : " << dataPosition.Coordinates.X << " m"  <<  endl;
	cout << "Y   command : " << dataCommand.Coordinates.Y << " m" << "     Position : " << dataPosition.Coordinates.Y << " m"  <<  endl;
	cout << "Z   command : " << dataCommand.Coordinates.Z << " m" << "     Position : " << dataPosition.Coordinates.Z << " m"  <<  endl;
	cout << "Theta X   command : " << dataCommand.Coordinates.ThetaX << " Rad" << "     Position : " << dataPosition.Coordinates.ThetaX << " Rad"  <<  endl;
	cout << "Theta Y   command : " << dataCommand.Coordinates.ThetaY << " Rad" << "     Position : " << dataPosition.Coordinates.ThetaY << " Rad"  <<  endl;
	cout << "Theta Z   command : " << dataCommand.Coordinates.ThetaZ << " Rad" << "     Position : " << dataPosition.Coordinates.ThetaZ << " Rad"  <<  endl << endl;
	cout << "Actuator 1   command : " << dataCommand_A.Actuators.Actuator1 << "°" << "     Position : " << dataPosition_A.Actuators.Actuator1 <<  endl;
	cout << "Actuator 2   command : " << dataCommand_A.Actuators.Actuator2 << "°" << "     Position : " << dataPosition_A.Actuators.Actuator2 <<  endl;
	cout << "Actuator 3   command : " << dataCommand_A.Actuators.Actuator3 << "°" << "     Position : " << dataPosition_A.Actuators.Actuator3 <<  endl;
	cout << "Actuator 4   command : " << dataCommand_A.Actuators.Actuator4 << "°" << "     Position : " << dataPosition_A.Actuators.Actuator4 <<  endl;
	cout << "Actuator 5   command : " << dataCommand_A.Actuators.Actuator5 << "°" << "     Position : " << dataPosition_A.Actuators.Actuator5 <<  endl;
	cout << "Actuator 6   command : " << dataCommand_A.Actuators.Actuator6 << "°" << "     Position : " << dataPosition_A.Actuators.Actuator6 <<  endl << endl;

	cout << "  Finger 1   command: " << dataCommand.Fingers.Finger1 << "     Position : " << dataPosition.Fingers.Finger1 <<  endl;
	cout << "  Finger 2   command: " << dataCommand.Fingers.Finger2 << "     Position : " << dataPosition.Fingers.Finger2 <<  endl;
	cout << "  Finger 3   command: " << dataCommand.Fingers.Finger3 << "     Position : " << dataPosition.Fingers.Finger3 <<  endl;
	cout << "Actuator 1   current : " << current.Actuators.Actuator1 << " A" << endl;
	cout << "Actuator 2   current : " << current.Actuators.Actuator2 << " A" << endl;
	cout << "Actuator 3   current : " << current.Actuators.Actuator3 << " A" << endl;
	cout << "Actuator 4   current : " << current.Actuators.Actuator4 << " A" << endl;
	cout << "Actuator 5   current : " << current.Actuators.Actuator5 << " A" << endl;
	cout << "Actuator 6   current : " << current.Actuators.Actuator6 << " A" << endl;
	cout << "Actuator 1   torque : " << torque.Actuators.Actuator1 << " N*m" << "     without gravity : " << torqueGravityFree.Actuators.Actuator1 << " N*m" <<  endl;
	cout << "Actuator 2   torque : " << torque.Actuators.Actuator2 << " N*m" << "     without gravity : " << torqueGravityFree.Actuators.Actuator2 << " N*m"  <<  endl;
	cout << "Actuator 3   torque : " << torque.Actuators.Actuator3 << " N*m" << "     without gravity : " << torqueGravityFree.Actuators.Actuator3 << " N*m"  <<  endl;
	cout << "Actuator 4   torque : " << torque.Actuators.Actuator4 << " N*m" << "     without gravity : " << torqueGravityFree.Actuators.Actuator4 << " N*m"  <<  endl;
	cout << "Actuator 5   torque : " << torque.Actuators.Actuator5 << " N*m" << "     without gravity : " << torqueGravityFree.Actuators.Actuator5 << " N*m"  <<  endl;
	cout << "Actuator 6   torque : " << torque.Actuators.Actuator6 << " N*m" << "     without gravity : " << torqueGravityFree.Actuators.Actuator6 << " N*m"  <<  endl;
	cout << "*********************************" << endl ;
		
printf("\033[2J");


  return RTC::RTC_OK;
}

extern "C"
{
 
  void Jaco_Test_PS4Init(RTC::Manager* manager)
  {
    coil::Properties profile(jaco_test_ps4_spec);
    manager->registerFactory(profile,
                             RTC::Create<Jaco_Test_PS4>,
                             RTC::Delete<Jaco_Test_PS4>);
  }
  
};


